#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_SPEC_VERSION")]
pub const KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_EXTENSION_NAME")]
pub const KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_external_semaphore_capabilities");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_PHYSICAL_DEVICE_EXTERNAL_SEMAPHORE_PROPERTIES_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetPhysicalDeviceExternalSemaphorePropertiesKHR");
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagsKHR.html)) · Alias <br/> VkExternalSemaphoreHandleTypeFlags - Bitmask of VkExternalSemaphoreHandleTypeFlagBits\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_VERSION_1_1\ntypedef VkFlags VkExternalSemaphoreHandleTypeFlags;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\ntypedef VkExternalSemaphoreHandleTypeFlags VkExternalSemaphoreHandleTypeFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::ExternalSemaphoreHandleTypeFlagBits`] is a bitmask type for setting a\nmask of zero or more [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html).\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExportSemaphoreCreateInfo`], [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html), [`crate::vk::ExternalSemaphoreProperties`]\n"]
#[doc(alias = "VkExternalSemaphoreHandleTypeFlagsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalSemaphoreHandleTypeFlagsKHR = crate::vk1_1::ExternalSemaphoreHandleTypeFlags;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreFeatureFlagsKHR.html)) · Alias <br/> VkExternalSemaphoreFeatureFlags - Bitmask of VkExternalSemaphoreFeatureFlagBitsKHR\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_VERSION_1_1\ntypedef VkFlags VkExternalSemaphoreFeatureFlags;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\ntypedef VkExternalSemaphoreFeatureFlags VkExternalSemaphoreFeatureFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::ExternalSemaphoreFeatureFlagBits`] is a bitmask type for setting a mask\nof zero or more [VkExternalSemaphoreFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreFeatureFlagBits.html).\n[](#_see_also)See Also\n----------\n\n[VkExternalSemaphoreFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreFeatureFlagBits.html), [`crate::vk::ExternalSemaphoreProperties`]\n"]
#[doc(alias = "VkExternalSemaphoreFeatureFlagsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalSemaphoreFeatureFlagsKHR = crate::vk1_1::ExternalSemaphoreFeatureFlags;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBitsKHR.html)) · Alias <br/> VkExternalSemaphoreHandleTypeFlagBits - Bitmask of valid external semaphore handle types\n[](#_c_specification)C Specification\n----------\n\nBits which **may** be set in[`crate::vk::PhysicalDeviceExternalSemaphoreInfo::handle_type`], specifying an\nexternal semaphore handle type, are:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef enum VkExternalSemaphoreHandleTypeFlagBits {\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_OPAQUE_FD_BIT = 0x00000001,\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_OPAQUE_WIN32_BIT = 0x00000002,\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_OPAQUE_WIN32_KMT_BIT = 0x00000004,\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_D3D12_FENCE_BIT = 0x00000008,\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_SYNC_FD_BIT = 0x00000010,\n  // Provided by VK_FUCHSIA_external_semaphore\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_ZIRCON_EVENT_BIT_FUCHSIA = 0x00000080,\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_D3D11_FENCE_BIT = VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_D3D12_FENCE_BIT,\n  // Provided by VK_KHR_external_semaphore_capabilities\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_OPAQUE_FD_BIT_KHR = VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_OPAQUE_FD_BIT,\n  // Provided by VK_KHR_external_semaphore_capabilities\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_OPAQUE_WIN32_BIT_KHR = VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_OPAQUE_WIN32_BIT,\n  // Provided by VK_KHR_external_semaphore_capabilities\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_OPAQUE_WIN32_KMT_BIT_KHR = VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_OPAQUE_WIN32_KMT_BIT,\n  // Provided by VK_KHR_external_semaphore_capabilities\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_D3D12_FENCE_BIT_KHR = VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_D3D12_FENCE_BIT,\n  // Provided by VK_KHR_external_semaphore_capabilities\n    VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_SYNC_FD_BIT_KHR = VK_EXTERNAL_SEMAPHORE_HANDLE_TYPE_SYNC_FD_BIT,\n} VkExternalSemaphoreHandleTypeFlagBits;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\ntypedef VkExternalSemaphoreHandleTypeFlagBits VkExternalSemaphoreHandleTypeFlagBitsKHR;\n```\n[](#_description)Description\n----------\n\n* [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_FD`] specifies a POSIX\n  file descriptor handle that has only limited valid usage outside of\n  Vulkan and other compatible APIs.\n  It **must** be compatible with the POSIX system calls `dup`, `dup2`,`close`, and the non-standard system call `dup3`.\n  Additionally, it **must** be transportable over a socket using an`SCM_RIGHTS` control message.\n  It owns a reference to the underlying synchronization primitive\n  represented by its Vulkan semaphore object.\n\n* [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_WIN32`] specifies an NT\n  handle that has only limited valid usage outside of Vulkan and other\n  compatible APIs.\n  It **must** be compatible with the functions `DuplicateHandle`,`CloseHandle`, `CompareObjectHandles`, `GetHandleInformation`,\n  and `SetHandleInformation`.\n  It owns a reference to the underlying synchronization primitive\n  represented by its Vulkan semaphore object.\n\n* [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_WIN32_KMT`] specifies a\n  global share handle that has only limited valid usage outside of Vulkan\n  and other compatible APIs.\n  It is not compatible with any native APIs.\n  It does not own a reference to the underlying synchronization primitive\n  represented by its Vulkan semaphore object, and will therefore become\n  invalid when all Vulkan semaphore objects associated with it are\n  destroyed.\n\n* [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::D3D12_FENCE`] specifies an NT\n  handle returned by `ID3D12Device`::`CreateSharedHandle` referring\n  to a Direct3D 12 fence, or `ID3D11Device5`::`CreateFence`referring to a Direct3D 11 fence.\n  It owns a reference to the underlying synchronization primitive\n  associated with the Direct3D fence.\n\n* [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::D3D11_FENCE`] is an alias of[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::D3D12_FENCE`] with the same\n  meaning.\n  It is provided for convenience and code clarity when interacting with\n  D3D11 fences.\n\n* [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::SYNC_FD`] specifies a POSIX\n  file descriptor handle to a Linux Sync File or Android Fence object.\n  It can be used with any native API accepting a valid sync file or fence\n  as input.\n  It owns a reference to the underlying synchronization primitive\n  associated with the file descriptor.\n  Implementations which support importing this handle type **must** accept\n  any type of sync or fence FD supported by the native system they are\n  running on.\n\n* [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::ZIRCON_EVENT_FUCHSIA`]specifies a handle to a Zircon event object.\n  It can be used with any native API that accepts a Zircon event handle.\n  Zircon event handles are created with `ZX_RIGHTS_BASIC` and`ZX_RIGHTS_SIGNAL` rights.\n  Vulkan on Fuchsia uses only the ZX\\_EVENT\\_SIGNALED bit when signaling or\n  waiting.\n\n|   |Note<br/><br/>Handles of type [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::SYNC_FD`]generated by the implementation may represent either Linux Sync Files or<br/>Android Fences at the implementation’s discretion.<br/>Applications **should** only use operations defined for both types of file<br/>descriptors, unless they know via means external to Vulkan the type of the<br/>file descriptor, or are prepared to deal with the system-defined operation<br/>failures resulting from using the wrong type.|\n|---|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nSome external semaphore handle types can only be shared within the same\nunderlying physical device and/or the same driver version, as defined in the\nfollowing table:\n\n|                        Handle type                         |[`crate::vk::PhysicalDeviceIDProperties`]::`driverUUID`|[`crate::vk::PhysicalDeviceIDProperties`]::`deviceUUID`|\n|------------------------------------------------------------|--------------------------------------------|--------------------------------------------|\n|     [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_FD`]      |                 Must match                 |                 Must match                 |\n|    [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_WIN32`]    |                 Must match                 |                 Must match                 |\n|  [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_WIN32_KMT`]  |                 Must match                 |                 Must match                 |\n|    [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::D3D12_FENCE`]     |                 Must match                 |                 Must match                 |\n|      [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::SYNC_FD`]       |               No restriction               |               No restriction               |\n|[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::ZIRCON_EVENT_FUCHSIA`]|               No restriction               |               No restriction               |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalSemaphoreHandleTypeFlagBits`], [`crate::vk::ImportSemaphoreFdInfoKHR`], [`crate::vk::ImportSemaphoreWin32HandleInfoKHR`], [`crate::vk::ImportSemaphoreZirconHandleInfoFUCHSIA`], [`crate::vk::PhysicalDeviceExternalSemaphoreInfo`], [`crate::vk::SemaphoreGetFdInfoKHR`], [`crate::vk::SemaphoreGetWin32HandleInfoKHR`], [`crate::vk::SemaphoreGetZirconHandleInfoFUCHSIA`]\n"]
#[doc(alias = "VkExternalSemaphoreHandleTypeFlagBitsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalSemaphoreHandleTypeFlagBitsKHR = crate::vk1_1::ExternalSemaphoreHandleTypeFlagBits;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreFeatureFlagBitsKHR.html)) · Alias <br/> VkExternalSemaphoreFeatureFlagBits - Bitfield describing features of an external semaphore handle type\n[](#_c_specification)C Specification\n----------\n\nPossible values of[`crate::vk::ExternalSemaphoreProperties::external_semaphore_features`],\nspecifying the features of an external semaphore handle type, are:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef enum VkExternalSemaphoreFeatureFlagBits {\n    VK_EXTERNAL_SEMAPHORE_FEATURE_EXPORTABLE_BIT = 0x00000001,\n    VK_EXTERNAL_SEMAPHORE_FEATURE_IMPORTABLE_BIT = 0x00000002,\n  // Provided by VK_KHR_external_semaphore_capabilities\n    VK_EXTERNAL_SEMAPHORE_FEATURE_EXPORTABLE_BIT_KHR = VK_EXTERNAL_SEMAPHORE_FEATURE_EXPORTABLE_BIT,\n  // Provided by VK_KHR_external_semaphore_capabilities\n    VK_EXTERNAL_SEMAPHORE_FEATURE_IMPORTABLE_BIT_KHR = VK_EXTERNAL_SEMAPHORE_FEATURE_IMPORTABLE_BIT,\n} VkExternalSemaphoreFeatureFlagBits;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\ntypedef VkExternalSemaphoreFeatureFlagBits VkExternalSemaphoreFeatureFlagBitsKHR;\n```\n[](#_description)Description\n----------\n\n* [`crate::vk::ExternalSemaphoreFeatureFlagBits::EXPORTABLE`] specifies that\n  handles of this type **can** be exported from Vulkan semaphore objects.\n\n* [`crate::vk::ExternalSemaphoreFeatureFlagBits::IMPORTABLE`] specifies that\n  handles of this type **can** be imported as Vulkan semaphore objects.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalSemaphoreFeatureFlagBits`]\n"]
#[doc(alias = "VkExternalSemaphoreFeatureFlagBitsKHR")]
#[allow(non_camel_case_types)]
pub type ExternalSemaphoreFeatureFlagBitsKHR = crate::vk1_1::ExternalSemaphoreFeatureFlagBits;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExternalSemaphoreInfoKHR.html)) · Alias <br/> VkPhysicalDeviceExternalSemaphoreInfo - Structure specifying semaphore creation parameters.\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceExternalSemaphoreInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceExternalSemaphoreInfo {\n    VkStructureType                          sType;\n    const void*                              pNext;\n    VkExternalSemaphoreHandleTypeFlagBits    handleType;\n} VkPhysicalDeviceExternalSemaphoreInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\ntypedef VkPhysicalDeviceExternalSemaphoreInfo VkPhysicalDeviceExternalSemaphoreInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `handleType` is a [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n  specifying the external semaphore handle type for which capabilities\n  will be returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExternalSemaphoreInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTERNAL_SEMAPHORE_INFO`]\n\n* []() VUID-VkPhysicalDeviceExternalSemaphoreInfo-pNext-pNext  \n  `pNext` **must** be `NULL` or a pointer to a valid instance of [`crate::vk::SemaphoreTypeCreateInfo`]\n\n* []() VUID-VkPhysicalDeviceExternalSemaphoreInfo-sType-unique  \n   The `sType` value of each struct in the `pNext` chain **must** be unique\n\n* []() VUID-VkPhysicalDeviceExternalSemaphoreInfo-handleType-parameter  \n  `handleType` **must** be a valid [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html), [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalSemaphoreProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalSemaphoreProperties`]\n"]
#[doc(alias = "VkPhysicalDeviceExternalSemaphoreInfoKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceExternalSemaphoreInfoKHR = crate::vk1_1::PhysicalDeviceExternalSemaphoreInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExternalSemaphoreInfoKHR.html)) · Alias <br/> VkPhysicalDeviceExternalSemaphoreInfo - Structure specifying semaphore creation parameters.\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceExternalSemaphoreInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkPhysicalDeviceExternalSemaphoreInfo {\n    VkStructureType                          sType;\n    const void*                              pNext;\n    VkExternalSemaphoreHandleTypeFlagBits    handleType;\n} VkPhysicalDeviceExternalSemaphoreInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\ntypedef VkPhysicalDeviceExternalSemaphoreInfo VkPhysicalDeviceExternalSemaphoreInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `handleType` is a [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n  specifying the external semaphore handle type for which capabilities\n  will be returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExternalSemaphoreInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTERNAL_SEMAPHORE_INFO`]\n\n* []() VUID-VkPhysicalDeviceExternalSemaphoreInfo-pNext-pNext  \n  `pNext` **must** be `NULL` or a pointer to a valid instance of [`crate::vk::SemaphoreTypeCreateInfo`]\n\n* []() VUID-VkPhysicalDeviceExternalSemaphoreInfo-sType-unique  \n   The `sType` value of each struct in the `pNext` chain **must** be unique\n\n* []() VUID-VkPhysicalDeviceExternalSemaphoreInfo-handleType-parameter  \n  `handleType` **must** be a valid [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html), [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalSemaphoreProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalSemaphoreProperties`]\n"]
#[doc(alias = "VkPhysicalDeviceExternalSemaphoreInfoKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceExternalSemaphoreInfoKHRBuilder<'a> = crate::vk1_1::PhysicalDeviceExternalSemaphoreInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphorePropertiesKHR.html)) · Alias <br/> VkExternalSemaphoreProperties - Structure describing supported external semaphore handle features\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalSemaphoreProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalSemaphoreProperties {\n    VkStructureType                       sType;\n    void*                                 pNext;\n    VkExternalSemaphoreHandleTypeFlags    exportFromImportedHandleTypes;\n    VkExternalSemaphoreHandleTypeFlags    compatibleHandleTypes;\n    VkExternalSemaphoreFeatureFlags       externalSemaphoreFeatures;\n} VkExternalSemaphoreProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\ntypedef VkExternalSemaphoreProperties VkExternalSemaphorePropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `exportFromImportedHandleTypes` is a bitmask of[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) specifying which types of\n  imported handle `handleType` **can** be exported from.\n\n* `compatibleHandleTypes` is a bitmask of[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) specifying handle types\n  which **can** be specified at the same time as `handleType` when\n  creating a semaphore.\n\n* `externalSemaphoreFeatures` is a bitmask of[VkExternalSemaphoreFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreFeatureFlagBits.html) describing the features of`handleType`.\n[](#_description)Description\n----------\n\nIf `handleType` is not supported by the implementation, then[`crate::vk::ExternalSemaphoreProperties::external_semaphore_features`] will be\nset to zero.\n\nValid Usage (Implicit)\n\n* []() VUID-VkExternalSemaphoreProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::EXTERNAL_SEMAPHORE_PROPERTIES`]\n\n* []() VUID-VkExternalSemaphoreProperties-pNext-pNext  \n  `pNext` **must** be `NULL`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalSemaphoreFeatureFlagBits`], [`crate::vk::ExternalSemaphoreHandleTypeFlagBits`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalSemaphoreProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalSemaphoreProperties`]\n"]
#[doc(alias = "VkExternalSemaphorePropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalSemaphorePropertiesKHR = crate::vk1_1::ExternalSemaphoreProperties;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphorePropertiesKHR.html)) · Alias <br/> VkExternalSemaphoreProperties - Structure describing supported external semaphore handle features\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ExternalSemaphoreProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkExternalSemaphoreProperties {\n    VkStructureType                       sType;\n    void*                                 pNext;\n    VkExternalSemaphoreHandleTypeFlags    exportFromImportedHandleTypes;\n    VkExternalSemaphoreHandleTypeFlags    compatibleHandleTypes;\n    VkExternalSemaphoreFeatureFlags       externalSemaphoreFeatures;\n} VkExternalSemaphoreProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\ntypedef VkExternalSemaphoreProperties VkExternalSemaphorePropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `exportFromImportedHandleTypes` is a bitmask of[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) specifying which types of\n  imported handle `handleType` **can** be exported from.\n\n* `compatibleHandleTypes` is a bitmask of[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) specifying handle types\n  which **can** be specified at the same time as `handleType` when\n  creating a semaphore.\n\n* `externalSemaphoreFeatures` is a bitmask of[VkExternalSemaphoreFeatureFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreFeatureFlagBits.html) describing the features of`handleType`.\n[](#_description)Description\n----------\n\nIf `handleType` is not supported by the implementation, then[`crate::vk::ExternalSemaphoreProperties::external_semaphore_features`] will be\nset to zero.\n\nValid Usage (Implicit)\n\n* []() VUID-VkExternalSemaphoreProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::EXTERNAL_SEMAPHORE_PROPERTIES`]\n\n* []() VUID-VkExternalSemaphoreProperties-pNext-pNext  \n  `pNext` **must** be `NULL`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalSemaphoreFeatureFlagBits`], [`crate::vk::ExternalSemaphoreHandleTypeFlagBits`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalSemaphoreProperties`], [`crate::vk::PFN_vkGetPhysicalDeviceExternalSemaphoreProperties`]\n"]
#[doc(alias = "VkExternalSemaphorePropertiesKHR")]
#[allow(non_camel_case_types)]
pub type ExternalSemaphorePropertiesKHRBuilder<'a> = crate::vk1_1::ExternalSemaphorePropertiesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceExternalSemaphorePropertiesKHR.html)) · Alias <br/> vkGetPhysicalDeviceExternalSemaphoreProperties - Function for querying external semaphore handle capabilities.\n[](#_c_specification)C Specification\n----------\n\nSemaphores **may** support import and export of their[payload](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-payloads) to external handles.\nTo query the external handle types supported by semaphores, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetPhysicalDeviceExternalSemaphoreProperties(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalSemaphoreInfo* pExternalSemaphoreInfo,\n    VkExternalSemaphoreProperties*              pExternalSemaphoreProperties);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\nvoid vkGetPhysicalDeviceExternalSemaphorePropertiesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalSemaphoreInfo* pExternalSemaphoreInfo,\n    VkExternalSemaphoreProperties*              pExternalSemaphoreProperties);\n```\n[](#_parameters)Parameters\n----------\n\n* `physicalDevice` is the physical device from which to query the\n  semaphore capabilities.\n\n* `pExternalSemaphoreInfo` is a pointer to a[`crate::vk::PhysicalDeviceExternalSemaphoreInfo`] structure describing the\n  parameters that would be consumed by [`crate::vk::PFN_vkCreateSemaphore`].\n\n* `pExternalSemaphoreProperties` is a pointer to a[`crate::vk::ExternalSemaphoreProperties`] structure in which capabilities are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceExternalSemaphoreProperties-physicalDevice-parameter  \n  `physicalDevice` **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceExternalSemaphoreProperties-pExternalSemaphoreInfo-parameter  \n  `pExternalSemaphoreInfo` **must** be a valid pointer to a valid [`crate::vk::PhysicalDeviceExternalSemaphoreInfo`] structure\n\n* []() VUID-vkGetPhysicalDeviceExternalSemaphoreProperties-pExternalSemaphoreProperties-parameter  \n  `pExternalSemaphoreProperties` **must** be a valid pointer to a [`crate::vk::ExternalSemaphoreProperties`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalSemaphoreProperties`], [`crate::vk::PhysicalDevice`], [`crate::vk::PhysicalDeviceExternalSemaphoreInfo`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetPhysicalDeviceExternalSemaphorePropertiesKHR = crate::vk1_1::PFN_vkGetPhysicalDeviceExternalSemaphoreProperties;
#[doc = "Provided by [`crate::extensions::khr_external_semaphore_capabilities`]"]
impl crate::vk1_0::StructureType {
    pub const PHYSICAL_DEVICE_EXTERNAL_SEMAPHORE_INFO_KHR: Self = Self::PHYSICAL_DEVICE_EXTERNAL_SEMAPHORE_INFO;
    pub const EXTERNAL_SEMAPHORE_PROPERTIES_KHR: Self = Self::EXTERNAL_SEMAPHORE_PROPERTIES;
}
#[doc = "Provided by [`crate::extensions::khr_external_semaphore_capabilities`]"]
impl crate::vk1_1::ExternalSemaphoreHandleTypeFlagBits {
    pub const OPAQUE_FD_KHR: Self = Self::OPAQUE_FD;
    pub const OPAQUE_WIN32_KHR: Self = Self::OPAQUE_WIN32;
    pub const OPAQUE_WIN32_KMT_KHR: Self = Self::OPAQUE_WIN32_KMT;
    pub const D3D12_FENCE_KHR: Self = Self::D3D12_FENCE;
    pub const SYNC_FD_KHR: Self = Self::SYNC_FD;
}
#[doc = "Provided by [`crate::extensions::khr_external_semaphore_capabilities`]"]
impl crate::vk1_1::ExternalSemaphoreFeatureFlagBits {
    pub const EXPORTABLE_KHR: Self = Self::EXPORTABLE;
    pub const IMPORTABLE_KHR: Self = Self::IMPORTABLE;
}
#[doc = "Provided by [`crate::extensions::khr_external_semaphore_capabilities`]"]
impl crate::InstanceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetPhysicalDeviceExternalSemaphorePropertiesKHR.html)) · Function <br/> vkGetPhysicalDeviceExternalSemaphoreProperties - Function for querying external semaphore handle capabilities.\n[](#_c_specification)C Specification\n----------\n\nSemaphores **may** support import and export of their[payload](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-payloads) to external handles.\nTo query the external handle types supported by semaphores, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetPhysicalDeviceExternalSemaphoreProperties(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalSemaphoreInfo* pExternalSemaphoreInfo,\n    VkExternalSemaphoreProperties*              pExternalSemaphoreProperties);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_external_semaphore_capabilities\nvoid vkGetPhysicalDeviceExternalSemaphorePropertiesKHR(\n    VkPhysicalDevice                            physicalDevice,\n    const VkPhysicalDeviceExternalSemaphoreInfo* pExternalSemaphoreInfo,\n    VkExternalSemaphoreProperties*              pExternalSemaphoreProperties);\n```\n[](#_parameters)Parameters\n----------\n\n* `physicalDevice` is the physical device from which to query the\n  semaphore capabilities.\n\n* `pExternalSemaphoreInfo` is a pointer to a[`crate::vk::PhysicalDeviceExternalSemaphoreInfo`] structure describing the\n  parameters that would be consumed by [`crate::vk::PFN_vkCreateSemaphore`].\n\n* `pExternalSemaphoreProperties` is a pointer to a[`crate::vk::ExternalSemaphoreProperties`] structure in which capabilities are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetPhysicalDeviceExternalSemaphoreProperties-physicalDevice-parameter  \n  `physicalDevice` **must** be a valid [`crate::vk::PhysicalDevice`] handle\n\n* []() VUID-vkGetPhysicalDeviceExternalSemaphoreProperties-pExternalSemaphoreInfo-parameter  \n  `pExternalSemaphoreInfo` **must** be a valid pointer to a valid [`crate::vk::PhysicalDeviceExternalSemaphoreInfo`] structure\n\n* []() VUID-vkGetPhysicalDeviceExternalSemaphoreProperties-pExternalSemaphoreProperties-parameter  \n  `pExternalSemaphoreProperties` **must** be a valid pointer to a [`crate::vk::ExternalSemaphoreProperties`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ExternalSemaphoreProperties`], [`crate::vk::PhysicalDevice`], [`crate::vk::PhysicalDeviceExternalSemaphoreInfo`]\n"]
    #[doc(alias = "vkGetPhysicalDeviceExternalSemaphorePropertiesKHR")]
    pub unsafe fn get_physical_device_external_semaphore_properties_khr(&self, physical_device: crate::vk1_0::PhysicalDevice, external_semaphore_info: &crate::vk1_1::PhysicalDeviceExternalSemaphoreInfo, external_semaphore_properties: Option<crate::vk1_1::ExternalSemaphoreProperties>) -> crate::vk1_1::ExternalSemaphoreProperties {
        let _function = self.get_physical_device_external_semaphore_properties_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut external_semaphore_properties = match external_semaphore_properties {
            Some(v) => v,
            None => Default::default(),
        };
        let _return = _function(physical_device as _, external_semaphore_info as _, &mut external_semaphore_properties);
        {
            external_semaphore_properties.p_next = std::ptr::null_mut() as _;
            external_semaphore_properties
        }
    }
}
